/**
 * Route Context Object
 *
 * @param {String} path
 * @param {Router} router
 */

'use strict';

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Object$defineProperty = require('babel-runtime/core-js/object/define-property')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var Route = function Route(path, router) {
  _classCallCheck(this, Route);

  this.path = path;
  var matched = router._recognizer.recognize(path);

  this.query = matched ? matched.queryParams : {};

  this.params = matched ? [].reduce.call(matched, function (prev, cur) {
    if (cur.params) {
      for (var key in cur.params) {
        prev[key] = cur.params[key];
      }
    }
    return prev;
  }, {}) : {};

  // private stuff
  this._aborted = false;
  def(this, '_matched', matched || router._notFoundHandler);
  def(this, '_router', router);
};

exports['default'] = Route;

function def(obj, key, val) {
  _Object$defineProperty(obj, key, {
    value: val,
    enumerable: false
  });
}
module.exports = exports['default'];